
/**
 * Write a description of class DateConversion here.
 * 
 * @author Stephen Bloch
 * @version Feb. 5, version 1
 */
public class DateConversion
{
/**
	dayFinder: finds the day of the week for any given date in 2001.
	@param	month	an int, the month number (Jan=1, Feb=2, etc.)
	@param	day		an int.
	@return			a String, the day of the week.

	<P>
	Examples: dayFinder(1,1) should return "Monday" <BR>
			  dayFinder(1,20) should return "Saturday" <br>
			  dayFinder(2,1) should return "Thursday" <br>
			  dayFinder(7,13) should return "Friday"
*/
	static String dayFinder (int month, int day)
	{
	final String[] dayName = {"Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"};

	int offset = daysAway(month,day) % 7;

	return dayName[offset];
	}




/**
	daysAway: find how many days a specified date is from the beginning of the year.
	@param	month	an int, the month number (Jan=1, Feb=2, etc.)
	@param	day		an int.	
	@return		an int, the number of days (e.g. Jan. 1 gives 1).

	<p>
	Examples: daysAway(1,1) should return 1 <br>
			  daysAway(1,20) should return 20 <br>
			  daysAway(2,1) should return 32 <br>
			  daysAway(12,31) should return 365
	<p>
	Note: this version of daysAway uses recursion rather than a loop.
*/
	static int daysAway (int month, int day)
	{
		final int[] days = {-999, 31,28,31,30,31,30,31,31,30,31,30,31};

		System.out.println ("Calling daysAway(" + month + "," + day + ")");
		if (month == 1)
			return day;
		else
			return days[month-1] + daysAway(month-1,day);
	}

/**
	Where we put all the standard test cases
*/
	public static void test ()
	{
		System.out.println ("Testing date conversion.");
		System.out.println ("daysAway(1,1) = " + daysAway(1,1) + " (should be 1)");
		System.out.println ("daysAway(1,20) = " + daysAway(1,20) + " (should be 20)");
		System.out.println ("daysAway(2,1) = " + daysAway(2,1) + " (should be 32)");
		System.out.println ("daysAway(12,31) = " + daysAway(12,31) + " (should be 365)");
		System.out.println ("daysAway(7,13) = " + daysAway(7,13) + " (should be 194?)");

		System.out.println ("dayFinder(1,1) = " + dayFinder(1,1) + " (should be Monday)");
		System.out.println ("dayFinder(1,20) = " + dayFinder(1,20) + " (should be Saturday)");
		System.out.println ("dayFinder(2,1) = " + dayFinder(2,1) + " (should be Thursday)");
		System.out.println ("dayFinder(7,13) = " + dayFinder(7,13) + " (should be Friday)");

		System.out.println ();
	}

}
